import type { BackendQueryFormat } from 'ts-common';
import type { QueryText } from './model';
import { query2Cypher } from './cypher/converter';
import { query2SQL } from './sql/queryConverterSql';
import type { DatabaseType } from 'ts-common/src/model/webSocket/dbConnection';

export const queryConverter = (JSONQuery: BackendQueryFormat, dbType: DatabaseType): QueryText => {
  if (dbType === 'neo4j' || dbType === 'memgraph') {
    return query2Cypher(JSONQuery);
  } else if (dbType === 'postgres') {
    return query2SQL(JSONQuery);
  }
  throw new Error('Unsupported database type');
};
